﻿using Splat;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FrontendAvalonia.Extensions
{
    public static class SplatExtensions
    {
        public static T GetRequiredService<T>(this IReadonlyDependencyResolver resolver, string? contract = null)
        {
            if (resolver is null)
            {
                throw new ArgumentNullException(nameof(resolver));
            }

            return resolver.GetService<T>(contract) ?? throw new InvalidOperationException($"Service {typeof(T).Name} was required but was not registered.");
        }
    }
}
