﻿using CommunityToolkit.Mvvm.ComponentModel;
using CommunityToolkit.Mvvm.Input;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using System.Xml.Linq;

namespace FrontendPlatformUno.ViewModels
{
    public class GamenightsViewModel : ObservableObject
    {
        private INavigator Navigator { get; }
        public string? Title { get; }
        public ICommand GoToLogin { get; }

        public GamenightsViewModel(INavigator navigator, IStringLocalizer stringLocalizer)
        {
            Navigator = navigator;
            Title = $"{stringLocalizer["ApplicationName"]}";
            GoToLogin = new AsyncRelayCommand(GoToLoginView);
        }

        private async Task GoToLoginView()
        {
            await Navigator.NavigateViewModelAsync<LoginViewModel>(this);
        }
    }
}
