use serde::{Serialize, Deserialize};
use uuid::Uuid;

use crate::schema::gamenight::Gamenight;

#[derive(Serialize, Deserialize)]
pub struct LoginResponse {
    pub login_result: bool,
    pub message: Option<String>,
    pub user_id: Option<Uuid>,
    pub jwt_token: Option<String>
}

impl LoginResponse {
    pub fn success(user_id: Uuid, token: String) -> Self {
        Self {
            login_result: true,
            message: None,
            user_id: Some(user_id),
            jwt_token: Some(token)
        }
    }
}

pub type GameNightsResponse = Vec<Gamenight>;